////////////////////////////////////////////////
//
// A ChaloBEST (http://chalobest.in/) initiative
// Author: Vivek (Macgregor Techknowlogy)
// License: GPLv3
//
//
package com.best.data;

import java.util.List;
import java.util.ArrayList;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.Hashtable;

import jsqlite.Callback;
import jsqlite.Exception;
import jsqlite.Stmt;

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.util.Vector;
import android.content.Context;

import com.best.ui.Best;
import java.util.zip.GZIPInputStream;

public class DBHandle {

	private static final String TAG = DBHandle.class.getName();
	public static Context me = null;
	
	public static String _DB_NAME = "chalobest";
	public static String _DATA_DIR = "data";
	public static String _DB_PATH = "data";
	public static int _DB_FILE_IDENTIFIER = com.best.ui.R.raw.chalobest_sqlite;
	
	public static void init(Context cont)
	{me = cont;}
	
	
	public static String[][] execQuery(String query , int maxRows)
	{
		String[][] resultSet = new String[ maxRows ][];
		List<String[]> listResultSet = new ArrayList<String[]>();
		try 
		{
			if( maxRows > 0 )
			{
				jsqlite.Database db = new jsqlite.Database();
			
				db.open( _DB_PATH, jsqlite.Constants.SQLITE_OPEN_READONLY );		
				Stmt resHandle = db.prepare( query );
				int resCounter = 0;
				while ( resHandle.step() ) 
				{
					if( resCounter < maxRows )
					{
						int no_col = resHandle.column_count();
						
						resultSet[ resCounter ] = new String[ no_col ];
						
						for(int index=0;index<no_col;index++)
							resultSet[ resCounter ][ index ] = resHandle.column_string( index );
							
						listResultSet.add(resultSet[ resCounter ]);
						resCounter++;
					}	
				}
			}
		} catch (Exception e) {System.out.println("DBHandle Excep:"+e.getMessage()); e.printStackTrace();}
		
		return( listResultSet.toArray( new String[ listResultSet.size() ][] ) );
	}
	
	public static String[][] execQuery(String query)
	{
		Hashtable resultSet = new Hashtable();
		String[][] ret = null;
		int no_col = -1;
		try 
		{			
			jsqlite.Database db = new jsqlite.Database();
		
			db.open( _DB_PATH, jsqlite.Constants.SQLITE_OPEN_READONLY );		
			Stmt resHandle = db.prepare( query );
			int resCounter = 0;
			while ( resHandle.step() ) 
			{
				no_col = resHandle.column_count();
				String[] row = new String[ no_col ];
				
				for(int index=0; index < no_col; index++ )
					row[ index ] = resHandle.column_string( index );
					
				resultSet.put( resCounter, row );	
				resCounter++;
			}	
			
			if( resultSet.size() > 0 && no_col > 0 )
			{
				ret = new String[ resultSet.size() ][ no_col ];
				for(int cnt = 0; cnt < resultSet.size(); cnt++ )
				{
					ret[ cnt ] = ( String[] )resultSet.get( cnt );
				}
			}	
		} catch (Exception e) { System.out.println("DBHandle Excep:"+e.getMessage()); e.printStackTrace();}
		return( ret );
	}
	
	public static boolean dbFileReady()
	{
		try{
			File dataPath = me.getDir( _DATA_DIR, 0 );
			File DBFile = new File( dataPath, _DB_NAME );
			
			if(!DBFile.exists())
			{	
				DBFile.createNewFile();
				InputStream dbin = me.getResources().openRawResource( _DB_FILE_IDENTIFIER );
				GZIPInputStream gzin = new GZIPInputStream( dbin );
				OutputStream os = new FileOutputStream( DBFile );
				int r;
				byte []b = new byte[ 1024 ];
				
				while((r = gzin.read(b)) != -1)
					os.write(b, 0, r);
				dbin.close();
				os.close();
				
			}
			_DB_PATH = DBFile.getAbsolutePath();
			return( true );
		}catch(java.lang.Exception e){ Best.log( " DBHandle ERR : " +e.getMessage() ); e.printStackTrace(); }
		return( false );
	}
}